* libbrl.s - libbrl.fnc source
* Copyright (C) 2001,2002 mor
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
* USA

		.cpu	68000

		.include	doscall.mac
		.include	basfnc.inc
		.include	rl.mac
		.include	rl_util.mac

		.xref		_libbrl_complete
		.xref		_libbrl_clist,_libbrl_cnum,_libbrl_c1len

		.text

	* CtH[Ve[u
		.dc.l		init,run,end,sys,break,ctrl_d
		.dc.l		_rts,_rts
		.dc.l		token,par,exe
		.dcb.l		5,0

par:	* p[^e[u
		.dc.l		readline_par
		.dc.l		_readline_par
		.dc.l		readlinelist_par
		.dc.l		readlineversion_par
		.dc.l		readlinesavefnckey_par
exe:	* sAhXe[u
		.dc.l		_readline
		.dc.l		__readline
		.dc.l		_readlinelist
		.dc.l		_readlineversion
		.dc.l		_readlinesavefnckey

init:
		bsr		_ReadLineSaveFnckey
		rts
sys:
		bsr		_ReadLineRestoreFnckey
run:
end:
break:
ctrl_d:
_rts:		rts


_readlinelist:
* int readlinelist( ary1_s )
		movea.l		par1ary(sp),a0
		moveq		#0,d0
		move.w		ary_type(a0),d0
		move.l		d0,_libbrl_c1len
		move.w		ary_siz(a0),d0
		addq.l		#1,d0
		move.l		d0,_libbrl_cnum
		lea		ary1dat(a0),a0
		move.l		a0,_libbrl_clist
		move.l		#_libbrl_complete,d0
		ric		d0


_readline:
* int readline( int, int, str_vp[255], str, ary1i(9), ary1c(12) )
sz:		.equ		sizeof_RLBUF
		lea		-sz(sp),sp

		move.w		sz+par1w(sp),_RL_WIN_X(sp)
		move.w		sz+par2w(sp),_RL_WIN_Y(sp)
		move.l		sz+par3s(sp),_RL_BUF(sp)
		move.l		#256,_RL_SIZE(sp)
		move.l		sz+par4s(sp),_RL_WORDS(sp)

		movea.l		sz+par5ary(sp),a0
		cmpi.w		#9,ary_siz(a0)
		bcs		ias
		lea		ary1dat(a0),a0
		move.l		(a0)+,_RL_YANK_BUF(sp)
		moveq		#9-1,d0
		lea		_RL_NULL(sp),a1
@@:		move.l		(a0)+,(a1)+
		dbra		d0,@b

		movea.l		sz+par6ary(sp),a0
		cmpi.w		#12,ary_siz(a0)
		bcs		cas
		lea		ary1dat(a0),a0
		moveq		#13-1,d0
		lea		_RL_COL(sp),a1
@@:		move.b		(a0)+,(a1)+
		dbra		d0,@b

		pea		(sp)
		bsr		_ReadLine
*		addq.l		#4,sp

*		lea		sz(sp),sp
		lea		4+sz(sp),sp
		ric		d0

ias:		lea		sz(sp),sp
		rqqf		-1,1,ia_mes
cas:		lea		sz(sp),sp
		rqqf		-2,2,ca_mes


__readline:
* int _readline( int )
		move.l		par1i(sp),-(sp)
		bsr		_ReadLine
		addq.l		#4,sp
		ric		d0


_readlineversion:
* str readlineversion()
		bsr		_ReadLineVersion
		ric		d0


_readlinesavefnckey:
		rvc


entry:	* sĂ܂ꍇ̃GgAhX
		move.w		#2,-(sp)
		pea		entrymes(pc)
		DOS		_FPUTS
		move.w		#1,(sp)
		DOS		_EXIT2


		.data

		.even
	* p[^IDe[u
readline_par:	.dc.w		int_val,int_val,str_vp,str_val,ary1_i,ary1_c,int_ret

_readline_par:	.dc.w		int_val
readlineversion_par:
		.dc.w		int_ret

readlinelist_par:
		.dc.w		ary1_s,int_ret

readlinesavefnckey_par:
		.dc.w		void_ret


token:	* g[Ne[u
		.dc.b		'readline',0
		.dc.b		'_readline',0
		.dc.b		'readlinelist',0
		.dc.b		'readlineversion',0
		.dc.b		'readlinesavefnckey',0
		.dc.b		0


	* bZ[W
entrymes:	.dc.b		'libbrl.fnc: BASIC̊O֐łBsł܂B',13,10,0
ia_mes:		.dc.b		'readline(libbrl.fnc): 5̔z񂪏܂Bret=-1,errno=1',0
ca_mes:		.dc.b		'readline(libbrl.fnc): 6̔z񂪏܂Bret=-2,errno=2',0


		.end		entry
* eof