/* complete.c - libbrl.fnc / BAStoC compile library
 * Copyright (C) 2000 Tachibana Eriko, 2001,2002 mor
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

/* System headers */
#include <string.h>

#ifdef __MSHORT__
#error gcc-mshortIvVȂł
#endif

/* Variables */
unsigned char *libbrl_clist;
int libbrl_cnum;
int libbrl_c1len;

/* Functions */
int libbrl_complete
	(unsigned char *buf, unsigned const char **top_ptr, int *len_ptr,
	 unsigned char *list_buf, int list_buf_len)
{
  int i;
  int n = 0;
  unsigned char *s = libbrl_clist;

  for (i = 0; i < libbrl_cnum && *s; ++i, s += libbrl_c1len)
    {
      if (strncasecmp (s, *top_ptr, *len_ptr) == 0)
	{
	  int l = strlen (s) + 2;

	  if ((list_buf_len -= l) < 0)
	    break;

	  list_buf[0] = 0;
	  strcpy (&list_buf[1], s);
	  list_buf += l;

	  ++n;
	}
    }

  return n;
}

/* EOF */
